# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _nonbondedslicing
else:
    import _nonbondedslicing

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import openmm

from openmm import unit

__version__ = "0.2.2"

class SlicedNonbondedForce(openmm.NonbondedForce):
    r"""
    This class implements sliced nonbonded interactions between particles, including a Coulomb force to represent
    electrostatics and a Lennard-Jones force to represent van der Waals interactions.  It optionally supports
    periodic boundary conditions and cutoffs for long range interactions.  Lennard-Jones interactions are
    calculated with the Lorentz-Berthelot combining rule: it uses the arithmetic mean of the sigmas and the
    geometric mean of the epsilons for the two interacting particles.

    The particles are classified into :math:`n` disjoint subsets, thus creating :math:`n(n+1)/2` distinct types
    of particle pairs.  Then, the total potential energy is sliced into this many parts by distinguishing the
    contributions of such pair types.  Optionally, variables stored as an :OpenMM:`Context` global parameters
    can multiply the Coulomb and/or Lennard-Jones parts of selected potential energy slices.  Changes in the
    values of these global parameters via setParameter_ will automatically modify the total potential energy of
    a SlicedNonbondedForce.  Derivatives with respect to scaling parameters can also be calculated upon request.

    .. _setParameter: http://docs.openmm.org/latest/api-python/generated/openmm.openmm.Context.html#openmm.openmm.Context.setParameter

    To use this class, create a SlicedNonbondedForce object, specifying the number :math:`n` of particle subsets.
    Then, call :func:`addParticle` once for every single particle in the System to define its force field
    parameters.  Alternatively, you can pass an existing :OpenMM:`NonbondedForce` object when creating a
    SlicedNonbondedForce object, so that the latter inherits all properties of the former.  After a particle has
    been added, you can modify its subset index from 0, the default value, to any positive integer lower than
    :math:`n` by calling :func:`setParticleSubset`.  You can also modify the force field parameters of an added
    particle by calling :func:`setParticleParameters`.  These two methods will have no effect on Contexts that
    already exist unless you call :func:`updateParametersInContext`.

    SlicedNonbondedForce also lets you specify *exceptions* via :func:`addException` and modify their parameters
    via :func:`setExceptionParameters`.  Exceptions are particular pairs of particles whose interactions should
    be computed based on different parameters than those defined for the individual particles.  This can be used
    to exclude certain interactions from the force calculation.

    By default, all energy slices of a SlicedNonbondedForce are added together, yielding the same total
    potential energy as a NonbondedForce with equal particle and exception parameters.  In addition, you can
    select one or more slices and multiply their Coulomb and/or Lennard-Jones contributions by variables
    referred to as *scaling parameters*.  For this, start by calling :func:`addGlobalParameter` to define
    a new Context parameter, then pass its name to :func:`addScalingParameter`.  The same scaling parameter
    can affect multiple slices, and two scaling parameters can affect a single slice, but only if they
    multiply the Coulomb and Lennard-Jones parts of that slice separately.

    With :func:`setScalingParameterDerivative`, you can request the derivative with respect to a scaling
    parameter.  All requested derivatives can then be evaluated for a particular :OpenMM:`State` by calling
    its getEnergyParameterDerivatives_ method.  For this, such State must have been generated from an
    :OpenMM:`Context` by passing ``True`` to the keyword ``getParameterDerivatives`` of the Context's
    getState_ method.

    .. _getState: http://docs.openmm.org/latest/api-python/generated/openmm.openmm.Context.html#openmm.openmm.Context.getState

    .. _getEnergyParameterDerivatives: http://docs.openmm.org/latest/api-python/generated/openmm.openmm.State.html#openmm.openmm.State.getEnergyParameterDerivatives

    Many molecular force fields omit Coulomb and Lennard-Jones interactions between particles separated by one
    or two bonds, while using modified parameters for those separated by three bonds (known as "1-4 interactions").
    This class provides a convenience method for this case called :func:`createExceptionsFromBonds`.  You pass to it
    a list of bonds and the scale factors to use for 1-4 interactions.  It identifies all pairs of particles which
    are separated by 1, 2, or 3 bonds, then automatically creates exceptions for them.

    When using a cutoff, by default Lennard-Jones interactions are sharply truncated at the cutoff distance.
    Optionally you can instead use a switching function to make the interaction smoothly go to zero over a finite
    distance range.  To enable this, call :func:`setUseSwitchingFunction`.  You must also call :func:`setSwitchingDistance`
    to specify the distance at which the interaction should begin to decrease.  The switching distance must be
    less than the cutoff distance.

    Another optional feature of this class (enabled by default) is to add a contribution to the energy which approximates
    the effect of all Lennard-Jones interactions beyond the cutoff in a periodic system.  When running a simulation
    at constant pressure, this can improve the quality of the result.  Call :func:`setUseDispersionCorrection` to set whether
    this should be used.

    In some applications, it is useful to be able to inexpensively change the parameters of small groups of particles.
    Usually this is done to interpolate between two sets of parameters.  For example, a titratable group might have
    two states it can exist in, each described by a different set of parameters for the atoms that make up the
    group.  You might then want to smoothly interpolate between the two states.  This is done by first calling
    :func:`addGlobalParameter` to define a Context parameter, then :func:`addParticleParameterOffset` to create a "parameter offset"
    that depends on the Context parameter.  Each offset defines the following:

    * A Context parameter used to interpolate between the states.
    * A single particle whose parameters are influenced by the Context parameter.
    * Three scale factors (chargeScale, sigmaScale, and epsilonScale) that specify how the Context parameter affects the particle.

    The "effective" parameters for a particle (those used to compute forces) are given by

    .. code-block:: python

       charge = baseCharge + param*chargeScale
       sigma = baseSigma + param*sigmaScale
       epsilon = baseEpsilon + param*epsilonScale

    where the ``base`` values are the ones specified by :func:`addParticle` and ``param`` is the current value
    of the Context parameter.  A single Context parameter can apply offsets to multiple particles,
    and multiple parameters can be used to apply offsets to the same particle.  Parameters can also be used
    to modify exceptions in exactly the same way by calling :func:`addExceptionParameterOffset`.  A context
    parameter cannot be used simultaneously to apply offsets and scale energy terms.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*

        Create a SlicedNonbondedForce.

        Parameters
        ----------
            numSubsets : int
                the number of particle subsets

        |

        *Overload 2:*

        Create a SlicedNonbondedForce having the properties of an existing :OpenMM:`NonbondedForce`.

        Parameters
        ----------
            force : :OpenMM:`NonbondedForce`
                the NonbondedForce object from which to instantiate this SlicedNonbondedForce
            numSubsets : int
                the number of particle subsets
        """
        _nonbondedslicing.SlicedNonbondedForce_swiginit(self, _nonbondedslicing.new_SlicedNonbondedForce(*args))

    def getPMEParametersInContext(self, context):
        r"""
        Get the parameters being used for PME in a particular Context.  Because some platforms have restrictions
        on the allowed grid sizes, the values that are actually used may be slightly different from those
        specified with setPMEParameters(), or the standard values calculated based on the Ewald error tolerance.
        See the manual for details.

        Parameters
        ----------
            context : Context
                the Context for which to get the parameters

        Returns
        -------
            alpha : double
                the separation parameter, measured in :math:`nm^{-1}`
            nx : int
                the number of grid points along the X axis
            ny : int
                the number of grid points along the Y axis
            nz : int
                the number of grid points along the Z axis
        """
        return _nonbondedslicing.SlicedNonbondedForce_getPMEParametersInContext(self, context)

    def getLJPMEParametersInContext(self, context):
        r"""
        Get the PME parameters being used for the dispersion term for LJPME in a particular Context.  Because some
        platforms have restrictions on the allowed grid sizes, the values that are actually used may be slightly different
        from those specified with setPMEParameters(), or the standard values calculated based on the Ewald error tolerance.
        See the manual for details.

        Parameters
        ----------
            context : Context
                the Context for which to get the parameters

        Returns
        -------
            alpha : double
                the separation parameter, measured in :math:`nm^{-1}`
            nx : int
                the number of grid points along the X axis
            ny : int
                the number of grid points along the Y axis
            nz : int
                the number of grid points along the Z axis
        """
        return _nonbondedslicing.SlicedNonbondedForce_getLJPMEParametersInContext(self, context)

    def updateParametersInContext(self, context):
        r"""
        Update the particle and exception parameters in a Context to match those stored in this Force object.  This method
        provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it.
        Simply call setParticleParameters() and setExceptionParameters() to modify this object's parameters, then call
        updateParametersInContext() to copy them over to the Context.

        This method has several limitations.  The only information it updates is the parameters of particles and exceptions.
        All other aspects of the Force (the nonbonded method, the cutoff distance, etc.) are unaffected and can only be
        changed by reinitializing the Context.  Furthermore, only the chargeProd, sigma, and epsilon values of an exception
        can be changed; the pair of particles involved in the exception cannot change.  Finally, this method cannot be used
        to add new particles or exceptions, only to change the parameters of existing ones.

        Parameters
        ----------
            context : Context
                the Context in which to update the parameters
        """
        return _nonbondedslicing.SlicedNonbondedForce_updateParametersInContext(self, context)

    def getNonbondedMethodName(self):
        r"""Get the name of the method used for handling long range nonbonded interactions."""
        return _nonbondedslicing.SlicedNonbondedForce_getNonbondedMethodName(self)

    def getNumSubsets(self):
        r"""Get the specified number of particle subsets."""
        return _nonbondedslicing.SlicedNonbondedForce_getNumSubsets(self)

    def getNumSlices(self):
        r"""Get the number of slices determined by the specified number of particle subsets."""
        return _nonbondedslicing.SlicedNonbondedForce_getNumSlices(self)

    def getParticleSubset(self, index):
        r"""
        Get the subset to which a particle belongs.

        Parameters
        ----------
            index : int
                the index of the particle for which to get the subset
        """
        return _nonbondedslicing.SlicedNonbondedForce_getParticleSubset(self, index)

    def setParticleSubset(self, index, subset):
        r"""
        Set the subset of a particle.

        Parameters
        ----------
            index : int
                the index of the particle for which to set the subset
            subset : int
                the subset to which this particle belongs
        """
        return _nonbondedslicing.SlicedNonbondedForce_setParticleSubset(self, index, subset)

    def addScalingParameter(self, parameter, subset1, subset2, includeCoulomb, includeLJ):
        r"""
        Add a scaling parameter to multiply a particular Coulomb slice. Its value will scale the
        Coulomb interactions between particles of a subset 1 with those of another (or the same)
        subset 2. The order of subset definition is irrelevant.

        Parameters
        ----------
            parameter : str
                the name of the global parameter.  It must have already been added
                with :func:`addGlobalParameter`. Its value can be modified at any time by
                calling `setParameter()` on the :OpenMM:`Context`
            subset1 : int
                the index of a particle subset.  Legal values are between 0 and the result of
                :func:`getNumSubsets`
            subset2 : int
                the index of a particle subset.  Legal values are between 0 and the result of
                :func:`getNumSubsets`
            includeCoulomb : bool
                whether this scaling parameter applies to Coulomb interactions
            includeLJ : bool
                whether this scaling parameter applies to Lennard-Jones interactions

        Returns
        -------
            index : int
                the index of scaling parameter that was added
        """
        return _nonbondedslicing.SlicedNonbondedForce_addScalingParameter(self, parameter, subset1, subset2, includeCoulomb, includeLJ)

    def getNumScalingParameters(self):
        r"""Get the number of scaling parameters."""
        return _nonbondedslicing.SlicedNonbondedForce_getNumScalingParameters(self)

    def getScalingParameter(self, index, parameter, arg4):
        r"""
        Get the scaling parameter applied to a particular nonbonded slice.

        Parameters
        ----------
            index : int
                the index of the scaling parameter to query, as returned by :func:`addScalingParameter`

        Returns
        -------
            parameter : str
                the name of the global parameter
            subset1 : int
                the smallest index of the two particle subsets
            subset2 : int
                the largest index of the two particle subsets
            includeCoulomb : bool
                whether this scaling parameter applies to Coulomb interactions
            includeLJ : bool
                whether this scaling parameter applies to Lennard-Jones interactions
        """
        return _nonbondedslicing.SlicedNonbondedForce_getScalingParameter(self, index, parameter, arg4)

    def setScalingParameter(self, index, parameter, subset1, subset2, includeCoulomb, includeLJ):
        r"""
        Modify an added scaling parameter.

        Parameters
        ----------
            index : int
                the index of the scaling parameter to modify, as returned by
                :func:`addExceptionChargeOffset`
            parameter : str
                the name of the global parameter.  It must have already been added
                with :func:`addGlobalParameter`. Its value can be modified at any time by
                calling `setParameter()` on the :OpenMM:`Context`
            subset1 : int
                the index of a particle subset.  Legal values are between 0 and the result of
                :func:`getNumSubsets`
            subset2 : int
                the index of a particle subset.  Legal values are between 0 and the result of
                :func:`getNumSubsets`
            includeCoulomb : bool
                whether this scaling parameter applies to Coulomb interactions
            includeLJ : bool
                whether this scaling parameter applies to Lennard-Jones interactions
        """
        return _nonbondedslicing.SlicedNonbondedForce_setScalingParameter(self, index, parameter, subset1, subset2, includeCoulomb, includeLJ)

    def addScalingParameterDerivative(self, parameter):
        r"""
        Request the derivative of this Force's energy with respect to a scaling parameter. This
        can be used to obtain the sum of particular energy slices. The parameter must have already
        been added with :func:`addGlobalParameter` and :func:`addScalingParameter`.

        Parameters
        ----------
            parameter : str
                the name of the parameter

        Returns
        -------
            index : int
                the index of scaling parameter derivative that was added
        """
        return _nonbondedslicing.SlicedNonbondedForce_addScalingParameterDerivative(self, parameter)

    def getNumScalingParameterDerivatives(self):
        r"""Get the number of requested scaling parameter derivatives."""
        return _nonbondedslicing.SlicedNonbondedForce_getNumScalingParameterDerivatives(self)

    def getScalingParameterDerivativeName(self, index):
        r"""
        Get the name of the global parameter associated with a requested scaling parameter
        derivative.

        Parameters
        ----------
            index : int
                the index of the parameter derivative, between 0 and the result of
                :func:`getNumScalingParameterDerivatives`
        """
        return _nonbondedslicing.SlicedNonbondedForce_getScalingParameterDerivativeName(self, index)

    def setScalingParameterDerivative(self, index, parameter):
        r"""
        Set the name of the global parameter to associate with a requested scaling parameter
        derivative.

        Parameters
        ----------
            index : int
                the index of the parameter derivative, between 0 and getNumScalingParameterDerivatives`
            parameter : str
                the name of the parameter
        """
        return _nonbondedslicing.SlicedNonbondedForce_setScalingParameterDerivative(self, index, parameter)

    def getUseCudaFFT(self):
        r"""
        Get whether to use CUDA Toolkit's cuFFT library when executing in the CUDA platform.
        The default value is `False`.
        """
        return _nonbondedslicing.SlicedNonbondedForce_getUseCudaFFT(self)

    def setUseCuFFT(self, use):
        r"""
        Set whether whether to use CUDA Toolkit's cuFFT library when executing in the CUDA platform.
        This choice has no effect when using other platforms or when the CUDA Toolkit is version 7.0
        or older.

        Parameters
        ----------
            use : bool
                whether to use the cuFFT library
        """
        return _nonbondedslicing.SlicedNonbondedForce_setUseCuFFT(self, use)

    @staticmethod
    def cast(force):
        return _nonbondedslicing.SlicedNonbondedForce_cast(force)

    @staticmethod
    def isinstance(force):
        return _nonbondedslicing.SlicedNonbondedForce_isinstance(force)
    __swig_destroy__ = _nonbondedslicing.delete_SlicedNonbondedForce

# Register SlicedNonbondedForce in _nonbondedslicing:
_nonbondedslicing.SlicedNonbondedForce_swigregister(SlicedNonbondedForce)

def SlicedNonbondedForce_cast(force):
    return _nonbondedslicing.SlicedNonbondedForce_cast(force)

def SlicedNonbondedForce_isinstance(force):
    return _nonbondedslicing.SlicedNonbondedForce_isinstance(force)



